/***************************************************************************
                          drv_info.c  -  description
                             -------------------
    begin             : 23.03.2008
    last modified     : 17.06.2020
    copyright         : (C) 2008 - 2020 by MHS-Elektronik GmbH & Co. KG, Germany
    author            : Klaus Demlehner, klaus@mhs-elektronik.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software, you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License           *
 *   version 2.1 as published by the Free Software Foundation.             *
 *                                                                         *
 ***************************************************************************/

/**
    Library to talk to Tiny-CAN devices. You find the latest versions at
       http://www.tiny-can.com/
**/
#include "global.h"
#include "config.h"
#include "drv_info.h"

/*
API Version 1.31
  - Initialisierungsvariable CanDrvMode eingefgt (0 = RS232, 1 = FTDI-USB)

API Version 1.32
  - Initialisierungsvariable MainThreadPriority THREAD_PRIORITY_REALTIME ergnzt
  - Initialisierungsvariable MainThreadPriority eingefgt

API Version 2.00
  - Untersttzung fr mehrere CAN-Module

API Version 2.02
  - Filter untersttzen RTR Frames

API Version 2.03
  - Der Timestamp untersttz den Modus "TIME_STAMP_HW_SW_UNIX", ist ein Hardware
    Timestamp verfgbar wird dieser benutzt ansonsten wird der Software Timestamp
    verwendet

API Version 2.10
  - Empfangene CAN Nachrichten knnen auch "CAN Bus Fehler Telegramme" enthalten, siehe
    can_types.h fr eine genauere Beschreibung.
    Die Funktion wird nur vom Tiny-CAN IV-XL Modul untersttzt.
  - (Nur Windows) CanDeviceOpen den Parameter "LocId" gibt es nicht mehr.
    Hat unter Win7 nicht richtig funktioniert und wurde deshalb gelscht, ein Bug im
    FTDI Treiber der nicht behoben werden konnte.

API Version 2.11
  - Mit der neuen Variable "AutoStopCan" kann der CAN-Bus automatisch bei schlieen
    des Devices gestoppt werden

API Version 3.00
  - Folgende Funktionsaufrufe wurden ergnzt:
       CanExGetDeviceListPerform
       CanExGetDeviceListGet
       CanExGetDeviceInfoPerform
       CanExGetDeviceInfoGet
       CanExGetAsStringCopy

API Version 3.10
  - Anpassungen fr Tiny-CAN LS: "CanStatus" um die Eigenschaft "BUS_FAILURE" ergnzt

API Version 3.11
  - "TCanFlagsBits" wurde um das Flag "FilHit" ergnzt

API Version 3.12
  - Neuer API Call: CanExSetEventAll
  
API Version 4.00  
  - CAN-FD Untersttzung
*/

const char DrvInfoStr[] =
   {"Description=Tiny-CAN API Treiber;"
    "Hardware=Tiny-CAN I-XL, Tiny-CAN II-XL, Tiny-CAN IV-XL, Tiny-CAN M1, Tiny-CAN M2, Tiny-CAN M3, Tiny-CAN M232, Tiny-CAN LS;"
    "Hardware IDs=0x43414E00, 0x43414E42, 0x43414E43, 0x43414E04, 0x43414E05, 0x43414E06, 0x43414E07, 0x43414E08, 0x43414E09;"
    "Version=7.0.3;"
    "Interface Type=USB;"
    "API Version=4.00;"
    "Autor=Klaus Demlehner;"
    "Homepage=www.mhs-elektronik.de"};
